/****************************************************************
**
** Definition of CIGLWidget class 
**
****************************************************************/

#ifndef CIGLWIDGET_H
#define CIGLWIDGET_H

#include <gl/glew.h>

#include <qgl.h>
#include <CI/CITrackball.h>
#include <MM/MMSG.h>


class CIGLWidget : public  QGLWidget 
{ 
	Q_OBJECT	
public:
  CIGLWidget( QWidget *parent=0, const char *name=0 );
  void initializeGL();
  void resizeGL( int w, int h );
  void paintGL();
	vcg::MMSG *sg;
	int editing;
	bool dirty;
	bool animBall;
	int mousex;
	int mousey;
	int moved;
public slots:
	void setEditing(bool);
	void setDirty(bool);
	void setTest(bool);
	void setTrackBall(bool);
	void smooth();
	void smoothX();
	void smoothY();
	void flatten();
	void ramp();
	void valley();
	void generateFace();
protected:
	void mousePressEvent(QMouseEvent*e);
	void mouseMoveEvent(QMouseEvent*e);
	void mouseReleaseEvent(QMouseEvent*e);
	void wheelEvent(QWheelEvent*e); 

private:
	vcg::Matrix44f rot;
	vcg::CITrackball tb;
	vcg::Point2i pickPos;
	float zoomFactor;
	bool rubberBanding;
	vcg::Point2i rbStart;
};

#endif
