/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

using namespace vcg; 
#include <qapplication.h>
#include <qdatetimeedit.h>



void MainForm::fileNew()
{
	InitDialog *inid= new InitDialog();
	if(inid->exec()){
			int vx =inid->spinBoxXSize->value();
			int vy =inid->spinBoxYSize->value();	
			sg.g->resize(vx,vy);
			QString buf;
			textGridSize->setText(buf.sprintf("Grid size %i x %i",vx,vy));
			}

}


void MainForm::fileOpen()
{
	QString s = QFileDialog::getOpenFileName(
		"levels",
		"xml grids (*.xml)",
		this,
		"open file dialog"
		"Choose one of cube map images \n(assuming	*_negx.jpg *_negx.png format " );

	sg.XMLRead(s);
	sg.g->setTexture("data/tile.png");
	
	GLView->setDirty(true);
}


void MainForm::fileSave()
{
	QPixmap qp = QPixmap::grabWindow(QApplication::desktop()->winId(),x()+GLView->x()+3,y()+GLView->y()+82,GLView->width(),GLView->height());
	QString s = QFileDialog::getSaveFileName(
		"levels",
		"xml grids (*.xml)",
		this,
		"save file dialog"
		"Choose one of cube map images \n(assuming	*_negx.jpg *_negx.png format " );
	QFile f(s);
	f.open(IO_WriteOnly);
	sg.XMLWrite(QTextStream(&f));
	f.close();
	QImage qi=qp.convertToImage();

	qi = qi.smoothScale(100,100);

	qi.save(s+".png","PNG");

}


void MainForm::fileSaveAs()
{

}


void MainForm::filePrint()
{

}


void MainForm::fileExit()
{
	QApplication::exit( 0 );
}

void MainForm::init()
{
	idleTimer.changeInterval(0);
	connect(&idleTimer, SIGNAL(timeout()),GLView,SLOT(update()));
	initSG();	
}


void MainForm::helpIndex()
{

}


void MainForm::helpContents()
{
}


void MainForm::helpAbout()
{

}







void MainForm::editGridSize()
{
    int ret=QMessageBox::question(this,"Changing ground size","Do you really want to change the size of the ground? It will destroy the geometry!",QMessageBox::Yes,QMessageBox::Cancel);
    if(ret==QMessageBox::Yes) fileNew();

}


void MainForm::chooseCubeMap()
{
	QString s = QFileDialog::getOpenFileName(
		"data/cubemaps",
		"Images (*.png *.jpg)",
		this,
		"open file dialog"
		"Choose one of cube map images \n(assuming	*_negx.jpg *_negx.png format " );
	// now strip the ending part of the cubemap name.
		int trun=s.findRev("/");
	s.remove(0,trun);
	s.prepend("data/cubemaps");
		QString extn=s.right(4);
		QString base=s.left(s.length()-9);
		QString name=base+extn;
		sg.c->textureBaseName=name;
		editCubeMap->setText(name);
	setCubeMap();
 }



void MainForm::setCubeMap()
{
 QString nm=editCubeMap->text();
 sg.c->textureBaseName=nm;
 sg.c->dirty=true;

}


void MainForm::initSG()
{
    GLView->sg=&sg;
	  sg.XMLRead("data/default.xml");
		sg.g->setTexture("data/tile.png");
	  
		GLView->setDirty(true);
}


void MainForm::setBallPos()
{
	sg.g->setBallOnSelectionCenter();
	sg.g->generateFace();
	GLView->animBall=!GLView->animBall;
}

void MainForm::setStartPos()
{
	sg.g->setStartOnSelectionCenter();
	sg.g->generateFace();
	//GLView->animBall=!GLView->animBall;
}


void MainForm::buttonSetStart_released()
{

}


void MainForm::setFinishPos()
{
sg.g->setFinishOnSelectionCenter();
	//sg.g->generateFace();
}


void MainForm::setLevelTime()
{
	SetTime *settimed= new SetTime();
	if(settimed->exec()){
		sg.g->leveltime = settimed->timeEdit1->value();
			
			//int newtime = settimed->timeEdit1->value();	
			//sg.leveltime=newtime;
			}
}


void MainForm::chooseTexture()
{
	QString s = QFileDialog::getOpenFileName(
		"data/texture",
		"Images (*.png *.jpg)",
		this,
		"open file dialog"
		"Choose one of cube map images \n(assuming	*_negx.jpg *_negx.png format " );
	// now strip the ending part of the cubemap name.


	int trun=s.findRev("/");
	s.remove(0,trun);
	s.prepend("data/texture");
        //sg.g->textureBaseName=name;
		editTexture->setText(s);

	//QString nm=editTexture->text();
          

        GLView->sg=&sg;
	  

		sg.g->setTexture(s);
	  
		GLView->setDirty(true);
		
}





void MainForm::setIce(bool i)
{
    //sg.g->ice=i;
	GLView->sg=&sg;
	sg.g->setIce(i);
	GLView->setDirty(true);

}

void MainForm::setGlue(bool i)
{
    //sg.g->glue=i;
		GLView->sg=&sg;
	sg.g->setGlue(i);
	GLView->setDirty(true);
}


void MainForm::chooseLateralTexture()
{
	QString s = QFileDialog::getOpenFileName(
		"data/texture",
		"Images (*.png *.jpg)",
		this,
		"open file dialog"
		"Choose one of cube map images \n(assuming	*_negx.jpg *_negx.png format " );
	// now strip the ending part of the cubemap name.

		int trun=s.findRev("/");
	s.remove(0,trun);
	s.prepend("data/texture");
        //sg.g->textureBaseName=name;
		editLateralTexture->setText(s);

	//QString nm=editTexture->text();
          

        GLView->sg=&sg;
	  
		sg.g->setLateralTexture(s);
	  
		GLView->setDirty(true);
		
}


void MainForm::setBumper()
{
    sg.g->setBumperOnSelection();
}




void MainForm::setBumperValue( int i )
{
	sg.g->setBumperResping(i);
}
